Subject: Cannot build source derivations with a custom TMPDIR
From: Leo Famulari <[email-masked]>
To: [email-masked]
Date: Wed, 21 Dec 2016 03:22:40 -0500
List-Id: <debbugs-submit.debbugs.gnu.org>

Since Guix 0.11.0-4.1f41, I can't build source derivations while using a
custom $TMPDIR.

I first described this issue in <http://bugs.gnu.org/25089>, but I'm
splitting it into its own report.

On my Debian system, I set 'TMPDIR=/home/leo/tmp/guix-build'.

Then, I can do this:

$ ./pre-inst-env guix build nmap
guix build: error: build failed: while setting up the build environment: changing into `/home/leo/tmp/guix-build/guix-build-nmap-7.40.tar.bz2.drv-0': No such file or directory

And some monitoring of the TMPDIR:

$ cd /home/leo/tmp/guix-build && inotifywait --monitor .
Setting up watches.
Watches established.
./ CREATE,ISDIR guix-build-nmap-7.40.tar.bz2.drv-0
./ ATTRIB,ISDIR guix-build-nmap-7.40.tar.bz2.drv-0
./ ATTRIB,ISDIR guix-build-nmap-7.40.tar.bz2.drv-0
./ OPEN,ISDIR guix-build-nmap-7.40.tar.bz2.drv-0
./ ACCESS,ISDIR guix-build-nmap-7.40.tar.bz2.drv-0
./ ACCESS,ISDIR guix-build-nmap-7.40.tar.bz2.drv-0
./ CLOSE_NOWRITE,CLOSE,ISDIR guix-build-nmap-7.40.tar.bz2.drv-0
./ DELETE,ISDIR guix-build-nmap-7.40.tar.bz2.drv-0

I ran the guix-daemon with strace, and I see these relevant lines:

15337 [pid 30675] mkdir("/home/leo/tmp/guix-build/guix-build-nmap-7.40.tar.bz2.drv-0", 0700) = 0
15338 [pid 30675] getegid()                   = 0
15339 [pid 30675] chown("/home/leo/tmp/guix-build/guix-build-nmap-7.40.tar.bz2.drv-0", -1, 0) = 0

... and just a bit later ...

15438 [pid 30693] chdir("/tmp/guix-build-nmap-7.40.tar.bz2.drv-0") = -1 ENOENT (No such file or directory)

I'm still trying to figure out where the problem is in the code. I guess
it's somewhere in these commits or code they interact with:

05ceb8dca download: Use the built-in 'download' builder when available.
f9aefa2d5 daemon: Add 'built-in-builders' RPC.
94d92c779 daemon: Add "builtin:download" derivation builder.